﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace ConsoleApplication1
{
    class Program
    {
        [DllImport("kernel32.dll")]
        static extern uint GetCurrentThreadId();

        [DllImport("TestWin32DLL.dll")]
        static extern int fnTestWin32DLL();

        static void Main(string[] args)
        {
            int count = 100000;
            PInvokeTest(1);
            CppcliTest(1);
            Cppcli2Test(1);

            Console.WriteLine("===================");

            PInvokeTest(count);
            CppcliTest(count);
            Cppcli2Test(count);
        }

        private static void PInvokeTest(int loopCount)
        {
            Stopwatch st = new Stopwatch();
            st.Start();

            for (int i = 0; i < loopCount; i++)
            {
                GetCurrentThreadId();
                fnTestWin32DLL();
            }

            st.Stop();

            Console.WriteLine(st.ElapsedTicks);
        }

        private static void CppcliTest(int loopCount)
        {
            TestLibrary.Class1 cl = new TestLibrary.Class1();

            Stopwatch st = new Stopwatch();
            st.Start();

            for (int i = 0; i < loopCount; i++)
            {
                cl.GetId();
            }

            st.Stop();

            Console.WriteLine(st.ElapsedTicks);
        }

        private static void Cppcli2Test(int count)
        {
            TestLibrary.Class1 cl = new TestLibrary.Class1();

            Stopwatch st = new Stopwatch();
            st.Start();

            cl.GetId2(count);
            st.Stop();
            Console.WriteLine(st.ElapsedTicks);
        }

    }
}
